package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CwBdVouchtempBExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CwBdVouchtempBExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andPkVouchtempBIsNull() {
            addCriterion("PK_VOUCHTEMP_B is null");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBIsNotNull() {
            addCriterion("PK_VOUCHTEMP_B is not null");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP_B =", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBNotEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP_B <>", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBGreaterThan(String value) {
            addCriterion("PK_VOUCHTEMP_B >", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBGreaterThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP_B >=", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBLessThan(String value) {
            addCriterion("PK_VOUCHTEMP_B <", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBLessThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP_B <=", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBLike(String value) {
            addCriterion("PK_VOUCHTEMP_B like", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBNotLike(String value) {
            addCriterion("PK_VOUCHTEMP_B not like", value, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBIn(List<String> values) {
            addCriterion("PK_VOUCHTEMP_B in", values, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBNotIn(List<String> values) {
            addCriterion("PK_VOUCHTEMP_B not in", values, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBBetween(String value1, String value2) {
            addCriterion("PK_VOUCHTEMP_B between", value1, value2, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBNotBetween(String value1, String value2) {
            addCriterion("PK_VOUCHTEMP_B not between", value1, value2, "pkVouchtempB");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempIsNull() {
            addCriterion("PK_VOUCHTEMP is null");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempIsNotNull() {
            addCriterion("PK_VOUCHTEMP is not null");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP =", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempNotEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP <>", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempGreaterThan(String value) {
            addCriterion("PK_VOUCHTEMP >", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempGreaterThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP >=", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempLessThan(String value) {
            addCriterion("PK_VOUCHTEMP <", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempLessThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHTEMP <=", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempLike(String value) {
            addCriterion("PK_VOUCHTEMP like", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempNotLike(String value) {
            addCriterion("PK_VOUCHTEMP not like", value, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempIn(List<String> values) {
            addCriterion("PK_VOUCHTEMP in", values, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempNotIn(List<String> values) {
            addCriterion("PK_VOUCHTEMP not in", values, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempBetween(String value1, String value2) {
            addCriterion("PK_VOUCHTEMP between", value1, value2, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andPkVouchtempNotBetween(String value1, String value2) {
            addCriterion("PK_VOUCHTEMP not between", value1, value2, "pkVouchtemp");
            return (Criteria) this;
        }

        public Criteria andAbstractsIsNull() {
            addCriterion("ABSTRACTS is null");
            return (Criteria) this;
        }

        public Criteria andAbstractsIsNotNull() {
            addCriterion("ABSTRACTS is not null");
            return (Criteria) this;
        }

        public Criteria andAbstractsEqualTo(String value) {
            addCriterion("ABSTRACTS =", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotEqualTo(String value) {
            addCriterion("ABSTRACTS <>", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsGreaterThan(String value) {
            addCriterion("ABSTRACTS >", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsGreaterThanOrEqualTo(String value) {
            addCriterion("ABSTRACTS >=", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsLessThan(String value) {
            addCriterion("ABSTRACTS <", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsLessThanOrEqualTo(String value) {
            addCriterion("ABSTRACTS <=", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsLike(String value) {
            addCriterion("ABSTRACTS like", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotLike(String value) {
            addCriterion("ABSTRACTS not like", value, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsIn(List<String> values) {
            addCriterion("ABSTRACTS in", values, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotIn(List<String> values) {
            addCriterion("ABSTRACTS not in", values, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsBetween(String value1, String value2) {
            addCriterion("ABSTRACTS between", value1, value2, "abstracts");
            return (Criteria) this;
        }

        public Criteria andAbstractsNotBetween(String value1, String value2) {
            addCriterion("ABSTRACTS not between", value1, value2, "abstracts");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjIsNull() {
            addCriterion("PK_ACCSUBJ is null");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjIsNotNull() {
            addCriterion("PK_ACCSUBJ is not null");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjEqualTo(String value) {
            addCriterion("PK_ACCSUBJ =", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotEqualTo(String value) {
            addCriterion("PK_ACCSUBJ <>", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjGreaterThan(String value) {
            addCriterion("PK_ACCSUBJ >", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjGreaterThanOrEqualTo(String value) {
            addCriterion("PK_ACCSUBJ >=", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjLessThan(String value) {
            addCriterion("PK_ACCSUBJ <", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjLessThanOrEqualTo(String value) {
            addCriterion("PK_ACCSUBJ <=", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjLike(String value) {
            addCriterion("PK_ACCSUBJ like", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotLike(String value) {
            addCriterion("PK_ACCSUBJ not like", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjIn(List<String> values) {
            addCriterion("PK_ACCSUBJ in", values, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotIn(List<String> values) {
            addCriterion("PK_ACCSUBJ not in", values, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjBetween(String value1, String value2) {
            addCriterion("PK_ACCSUBJ between", value1, value2, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotBetween(String value1, String value2) {
            addCriterion("PK_ACCSUBJ not between", value1, value2, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andSubjnameIsNull() {
            addCriterion("SUBJNAME is null");
            return (Criteria) this;
        }

        public Criteria andSubjnameIsNotNull() {
            addCriterion("SUBJNAME is not null");
            return (Criteria) this;
        }

        public Criteria andSubjnameEqualTo(String value) {
            addCriterion("SUBJNAME =", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameNotEqualTo(String value) {
            addCriterion("SUBJNAME <>", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameGreaterThan(String value) {
            addCriterion("SUBJNAME >", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameGreaterThanOrEqualTo(String value) {
            addCriterion("SUBJNAME >=", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameLessThan(String value) {
            addCriterion("SUBJNAME <", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameLessThanOrEqualTo(String value) {
            addCriterion("SUBJNAME <=", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameLike(String value) {
            addCriterion("SUBJNAME like", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameNotLike(String value) {
            addCriterion("SUBJNAME not like", value, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameIn(List<String> values) {
            addCriterion("SUBJNAME in", values, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameNotIn(List<String> values) {
            addCriterion("SUBJNAME not in", values, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameBetween(String value1, String value2) {
            addCriterion("SUBJNAME between", value1, value2, "subjname");
            return (Criteria) this;
        }

        public Criteria andSubjnameNotBetween(String value1, String value2) {
            addCriterion("SUBJNAME not between", value1, value2, "subjname");
            return (Criteria) this;
        }

        public Criteria andDirectionIsNull() {
            addCriterion("DIRECTION is null");
            return (Criteria) this;
        }

        public Criteria andDirectionIsNotNull() {
            addCriterion("DIRECTION is not null");
            return (Criteria) this;
        }

        public Criteria andDirectionEqualTo(String value) {
            addCriterion("DIRECTION =", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionNotEqualTo(String value) {
            addCriterion("DIRECTION <>", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionGreaterThan(String value) {
            addCriterion("DIRECTION >", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionGreaterThanOrEqualTo(String value) {
            addCriterion("DIRECTION >=", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionLessThan(String value) {
            addCriterion("DIRECTION <", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionLessThanOrEqualTo(String value) {
            addCriterion("DIRECTION <=", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionLike(String value) {
            addCriterion("DIRECTION like", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionNotLike(String value) {
            addCriterion("DIRECTION not like", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionIn(List<String> values) {
            addCriterion("DIRECTION in", values, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionNotIn(List<String> values) {
            addCriterion("DIRECTION not in", values, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionBetween(String value1, String value2) {
            addCriterion("DIRECTION between", value1, value2, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionNotBetween(String value1, String value2) {
            addCriterion("DIRECTION not between", value1, value2, "direction");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeIsNull() {
            addCriterion("PK_CURRTYPE is null");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeIsNotNull() {
            addCriterion("PK_CURRTYPE is not null");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeEqualTo(String value) {
            addCriterion("PK_CURRTYPE =", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeNotEqualTo(String value) {
            addCriterion("PK_CURRTYPE <>", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeGreaterThan(String value) {
            addCriterion("PK_CURRTYPE >", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeGreaterThanOrEqualTo(String value) {
            addCriterion("PK_CURRTYPE >=", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeLessThan(String value) {
            addCriterion("PK_CURRTYPE <", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeLessThanOrEqualTo(String value) {
            addCriterion("PK_CURRTYPE <=", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeLike(String value) {
            addCriterion("PK_CURRTYPE like", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeNotLike(String value) {
            addCriterion("PK_CURRTYPE not like", value, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeIn(List<String> values) {
            addCriterion("PK_CURRTYPE in", values, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeNotIn(List<String> values) {
            addCriterion("PK_CURRTYPE not in", values, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeBetween(String value1, String value2) {
            addCriterion("PK_CURRTYPE between", value1, value2, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andPkCurrtypeNotBetween(String value1, String value2) {
            addCriterion("PK_CURRTYPE not between", value1, value2, "pkCurrtype");
            return (Criteria) this;
        }

        public Criteria andOrimoneyIsNull() {
            addCriterion("ORIMONEY is null");
            return (Criteria) this;
        }

        public Criteria andOrimoneyIsNotNull() {
            addCriterion("ORIMONEY is not null");
            return (Criteria) this;
        }

        public Criteria andOrimoneyEqualTo(String value) {
            addCriterion("ORIMONEY =", value, "orimoney");
            return (Criteria) this;
        }

        public Criteria andOrimoneyNotEqualTo(String value) {
            addCriterion("ORIMONEY <>", value, "orimoney");
            return (Criteria) this;
        }

        public Criteria andOrimoneyGreaterThan(String value) {
            addCriterion("ORIMONEY >", value, "orimoney");
            return (Criteria) this;
        }

        public Criteria andOrimoneyGreaterThanOrEqualTo(String value) {
            addCriterion("ORIMONEY >=", value, "orimoney");
            return (Criteria) this;
        }

        public Criteria andOrimoneyLessThan(String value) {
            addCriterion("ORIMONEY <", value, "orimoney");
            return (Criteria) this;
        }

        public Criteria andOrimoneyLessThanOrEqualTo(String value) {
            addCriterion("ORIMONEY <=", value, "orimoney");
            return (Criteria) this;
        }

        public Criteria andOrimoneyLike(String value) {
            addCriterion("ORIMONEY like", value, "orimoney");
            return (Criteria) this;
        }

        public Criteria andOrimoneyNotLike(String value) {
            addCriterion("ORIMONEY not like", value, "orimoney");
            return (Criteria) this;
        }

        public Criteria andOrimoneyIn(List<String> values) {
            addCriterion("ORIMONEY in", values, "orimoney");
            return (Criteria) this;
        }

        public Criteria andOrimoneyNotIn(List<String> values) {
            addCriterion("ORIMONEY not in", values, "orimoney");
            return (Criteria) this;
        }

        public Criteria andOrimoneyBetween(String value1, String value2) {
            addCriterion("ORIMONEY between", value1, value2, "orimoney");
            return (Criteria) this;
        }

        public Criteria andOrimoneyNotBetween(String value1, String value2) {
            addCriterion("ORIMONEY not between", value1, value2, "orimoney");
            return (Criteria) this;
        }

        public Criteria andBasemoneyIsNull() {
            addCriterion("BASEMONEY is null");
            return (Criteria) this;
        }

        public Criteria andBasemoneyIsNotNull() {
            addCriterion("BASEMONEY is not null");
            return (Criteria) this;
        }

        public Criteria andBasemoneyEqualTo(String value) {
            addCriterion("BASEMONEY =", value, "basemoney");
            return (Criteria) this;
        }

        public Criteria andBasemoneyNotEqualTo(String value) {
            addCriterion("BASEMONEY <>", value, "basemoney");
            return (Criteria) this;
        }

        public Criteria andBasemoneyGreaterThan(String value) {
            addCriterion("BASEMONEY >", value, "basemoney");
            return (Criteria) this;
        }

        public Criteria andBasemoneyGreaterThanOrEqualTo(String value) {
            addCriterion("BASEMONEY >=", value, "basemoney");
            return (Criteria) this;
        }

        public Criteria andBasemoneyLessThan(String value) {
            addCriterion("BASEMONEY <", value, "basemoney");
            return (Criteria) this;
        }

        public Criteria andBasemoneyLessThanOrEqualTo(String value) {
            addCriterion("BASEMONEY <=", value, "basemoney");
            return (Criteria) this;
        }

        public Criteria andBasemoneyLike(String value) {
            addCriterion("BASEMONEY like", value, "basemoney");
            return (Criteria) this;
        }

        public Criteria andBasemoneyNotLike(String value) {
            addCriterion("BASEMONEY not like", value, "basemoney");
            return (Criteria) this;
        }

        public Criteria andBasemoneyIn(List<String> values) {
            addCriterion("BASEMONEY in", values, "basemoney");
            return (Criteria) this;
        }

        public Criteria andBasemoneyNotIn(List<String> values) {
            addCriterion("BASEMONEY not in", values, "basemoney");
            return (Criteria) this;
        }

        public Criteria andBasemoneyBetween(String value1, String value2) {
            addCriterion("BASEMONEY between", value1, value2, "basemoney");
            return (Criteria) this;
        }

        public Criteria andBasemoneyNotBetween(String value1, String value2) {
            addCriterion("BASEMONEY not between", value1, value2, "basemoney");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeIsNull() {
            addCriterion("MULTIPLE_TYPE is null");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeIsNotNull() {
            addCriterion("MULTIPLE_TYPE is not null");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeEqualTo(String value) {
            addCriterion("MULTIPLE_TYPE =", value, "multipleType");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeNotEqualTo(String value) {
            addCriterion("MULTIPLE_TYPE <>", value, "multipleType");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeGreaterThan(String value) {
            addCriterion("MULTIPLE_TYPE >", value, "multipleType");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeGreaterThanOrEqualTo(String value) {
            addCriterion("MULTIPLE_TYPE >=", value, "multipleType");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeLessThan(String value) {
            addCriterion("MULTIPLE_TYPE <", value, "multipleType");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeLessThanOrEqualTo(String value) {
            addCriterion("MULTIPLE_TYPE <=", value, "multipleType");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeLike(String value) {
            addCriterion("MULTIPLE_TYPE like", value, "multipleType");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeNotLike(String value) {
            addCriterion("MULTIPLE_TYPE not like", value, "multipleType");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeIn(List<String> values) {
            addCriterion("MULTIPLE_TYPE in", values, "multipleType");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeNotIn(List<String> values) {
            addCriterion("MULTIPLE_TYPE not in", values, "multipleType");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeBetween(String value1, String value2) {
            addCriterion("MULTIPLE_TYPE between", value1, value2, "multipleType");
            return (Criteria) this;
        }

        public Criteria andMultipleTypeNotBetween(String value1, String value2) {
            addCriterion("MULTIPLE_TYPE not between", value1, value2, "multipleType");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}